﻿using System;
using System.IO.Ports;
using System.Windows.Forms;

namespace SerialGraph
{
    public partial class Form1 : Form
    {
        SerialPort serialPort;
        double graphX = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void buttonConnect_Click(object sender, EventArgs e)
        {
            if (this.serialPort != null && this.serialPort.IsOpen)
            {
                this.serialPort.Close();
                buttonConnect.Text = "connect";
                this.textBoxPort.Enabled = true;
                this.textBoxBaudRate.Enabled = true;
            }
            else
            {
                this.serialPort = new SerialPort(textBoxPort.Text);
                this.serialPort.BaudRate = Convert.ToInt32(textBoxBaudRate.Text);
                this.serialPort.Parity = Parity.None;
                this.serialPort.StopBits = StopBits.One;
                this.serialPort.DataBits = 8;
                this.serialPort.Handshake = Handshake.None;
                this.serialPort.RtsEnable = true;

                this.serialPort.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);

                try
                {
                    this.serialPort.Open();
                    this.chart1.Series[0].Points.Clear();
                    this.textBoxPort.Enabled = false;
                    this.textBoxBaudRate.Enabled = false;
                    buttonConnect.Text = "disconnect";
                    textBoxOutput.Text = "";
                }
                catch (Exception ex)
                {
                    textBoxOutput.AppendText(ex.Message);
                }
            }
        }

        private void DataReceivedHandler(object sender, SerialDataReceivedEventArgs e)
        {
            SerialPort sp = (SerialPort)sender;
            double indata = 0.0;

            try
            {
                indata = (double)Convert.ToInt16(sp.ReadExisting().Trim());
            } catch(Exception)
            {
                /*
                textBoxOutput.Invoke(new Action(() =>
                {
                    textBoxOutput.AppendText(ex.Message + "\n");
                    textBoxOutput.ScrollToCaret();
                }));
                */
                return;
            }

            chart1.Invoke(new Action(() =>
            {
                chart1.Series[0].Points.AddXY(graphX, indata);
                graphX += 1.0;
            }));

            textBoxOutput.Invoke(new Action(() =>
            {
                textBoxOutput.AppendText(indata.ToString() + "\n");
                textBoxOutput.ScrollToCaret();
            }));
        }
    }
}
